import { Bounds as F, Rectangle as C, Container as M, Graphics as x, BigPool as b } from "pixi.js";
import { F as _, E as p } from "./index-C-iY-lCt.js";
var l = /* @__PURE__ */ ((e) => (e.Margin = "margin", e.Padding = "padding", e.Border = "border", e.Flex = "flex", e.Content = "content", e))(l || {});
function w(e, t) {
  const r = `getComputed${t.charAt(0).toUpperCase() + t.slice(1)}`;
  return {
    top: e.yoga[r](p.Top),
    right: e.yoga[r](p.Right),
    bottom: e.yoga[r](p.Bottom),
    left: e.yoga[r](p.Left)
  };
}
function B(e, t) {
  const { width: r, height: h } = e.computedLayout, a = w(e, "margin"), i = w(e, "border"), c = w(e, "padding"), n = t.get(
    "margin"
    /* Margin */
  );
  n.outer.x = -a.left, n.outer.y = -a.top, n.outer.width = r + a.left + a.right, n.outer.height = h + a.top + a.bottom, n.inner.x = 0, n.inner.y = 0, n.inner.width = r, n.inner.height = h;
  const o = t.get(
    "border"
    /* Border */
  );
  o.outer.x = 0, o.outer.y = 0, o.outer.width = r, o.outer.height = h, o.inner.x = i.left, o.inner.y = i.top, o.inner.width = r - i.left - i.right, o.inner.height = h - i.top - i.bottom;
  const s = t.get(
    "padding"
    /* Padding */
  );
  s.outer.copyFrom(o.inner), s.inner.x = c.left + i.left, s.inner.y = c.top + i.top, s.inner.width = r - c.left - c.right - i.left - i.right, s.inner.height = h - c.top - c.bottom - i.top - i.bottom, E(e, t);
}
function E(e, t) {
  var r;
  const h = t.get(
    "flex"
    /* Flex */
  ), a = t.get(
    "padding"
    /* Padding */
  );
  h.outer.copyFrom(a.inner);
  const i = new F(), c = e.yoga.getChildCount();
  for (let o = 0; o < c; o++) {
    const d = e.yoga.getChild(o).getComputedLayout();
    i.addRect(
      new C(d.left, d.top, d.width, d.height)
    );
  }
  const n = e.yoga.getFlexDirection();
  n === _.Column || n === _.ColumnReverse ? (i.width = h.outer.width, i.x = h.outer.x) : (i.height = h.outer.height, i.y = h.outer.y), (r = h.inner) == null || r.copyFrom(i.rectangle), t.get(
    "content"
    /* Content */
  ).outer.copyFrom(i.rectangle);
}
var O = Object.defineProperty, A = (e, t, r) => t in e ? O(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, v = (e, t, r) => A(e, typeof t != "symbol" ? t + "" : t, r);
function P(e, t, r) {
  const h = Math.round(e[0] + (t[0] - e[0]) * r), a = Math.round(e[1] + (t[1] - e[1]) * r), i = Math.round(e[2] + (t[2] - e[2]) * r);
  return `rgb(${h},${a},${i})`;
}
class G extends M {
  constructor() {
    super(), v(this, "graphics"), v(this, "heatGraphics"), this.graphics = /* @__PURE__ */ new Map(), Object.values(l).forEach((t) => {
      const r = new x();
      this.graphics.set(t, r), this.addChild(r);
    }), this.heatGraphics = new x(), this.addChild(this.heatGraphics);
  }
  /**
   * Initialize the debug object with region data
   */
  init(t) {
    const { target: r, alpha: h, heat: a } = t;
    t.heatOnly || Object.entries(t).forEach(([n, o]) => {
      if (n === "target" || n === "alpha" || n === "heat" || n === "heatOnly") return;
      o = o;
      const s = this.graphics.get(n);
      if (!(!s || !o.draw))
        if (o.inner)
          this.drawCutBox(s, o.outer, o.inner, o.color, h);
        else {
          const { x: d, y: u, width: g, height: m } = o.outer;
          s.rect(d, u, g, Math.max(m, 1)), s.fill({ color: o.color, alpha: h });
        }
    });
    const { invalidationCount: i, draw: c } = a;
    if (i > 0 && c) {
      const o = Math.min(i / 20, 1), s = t[l.Margin], g = P([255, 255, 0], [255, 0, 0], o);
      this.heatGraphics.rect(
        s.outer.x,
        s.outer.y,
        s.outer.width,
        s.outer.height
      ), this.heatGraphics.fill({ color: g, alpha: Math.min(0.3, o) }), this.heatGraphics.stroke({ color: g, alpha: Math.max(0.3, o), pixelLine: !0 });
    }
    this.position.set(r.x, r.y);
  }
  /**
   * Reset the debug object's state
   */
  reset() {
    this.graphics.forEach((t) => t.clear()), this.heatGraphics.clear(), this.removeFromParent();
  }
  /**
   * Draw a box with a cut-out center
   */
  drawCutBox(t, r, h, a, i) {
    const { x: c, y: n, width: o, height: s } = r, { x: d, y: u, width: g, height: m } = h;
    t.rect(c, n, o, s), t.fill({ color: a, alpha: i }), t.rect(d, u, g, m), t.cut();
  }
}
var R = Object.defineProperty, $ = (e, t, r) => t in e ? R(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, f = (e, t, r) => $(e, typeof t != "symbol" ? t + "" : t, r);
class y {
  constructor() {
    f(this, "holder", new M()), f(this, "regions", /* @__PURE__ */ new Map()), f(this, "colors", {
      [l.Margin]: "#B68655",
      [l.Padding]: "#BAC57F",
      [l.Border]: "#E7C583",
      [l.Content]: "#89B1BE",
      [l.Flex]: "#6E28D9"
    }), f(this, "alpha", 0.75), Object.values(l).forEach((t) => {
      this.regions.set(t, {
        outer: new C(),
        inner: new C()
      });
    }), this.holder.__devtoolIgnore = !0, this.holder.__devtoolIgnoreChildren = !0, this.holder.eventMode = "none", this.holder.interactiveChildren = !1;
  }
  /**
   * Clean up previous render state
   */
  reset() {
    for (let t = this.holder.children.length - 1; t >= 0; t--) {
      const r = this.holder.children[t];
      b.return(r);
    }
  }
  /**
   * Render debug visuals for the given layout
   */
  render(t) {
    B(t, this.regions);
    const r = Object.values(l).reduce(
      (n, o) => {
        const s = this.regions.get(o);
        if (!s) return n;
        const d = `debugDraw${o.charAt(0).toUpperCase()}${o.slice(1)}`;
        return n[o] = {
          ...s,
          color: this.colors[o],
          draw: t._styles.custom[d] ?? !0
        }, n;
      },
      {}
    ), { left: h, top: a } = t.computedLayout, i = t.target.getGlobalPosition(), c = b.get(G, {
      ...r,
      target: { x: i.x + h, y: i.y + a },
      alpha: this.alpha,
      heat: {
        invalidationCount: t._modificationCount,
        draw: t._styles.custom.debugHeat !== !1
      },
      heatOnly: !t._styles.custom.debug
    });
    this.holder.addChildAt(c, 0);
  }
  /**
   * Clean up the debug renderer
   */
  destroy() {
    this.reset(), this.holder.destroy(), this.regions.clear();
  }
}
export {
  y as DebugRenderer
};
//# sourceMappingURL=DebugRenderer-DcvJLrrD.js.map
