import { Element } from '../engine/reactive';
import { ComponentFunction } from '../engine/signal';
import { DisplayObjectProps } from './types/DisplayObject';

declare const CanvasDOMContainer_base: {
    new (): {
        [x: string]: any;
        "__#1@#canvasContext": {
            [key: string]: any;
        } | null;
        isFlex: boolean;
        fullProps: import('..').Props;
        isMounted: boolean;
        _anchorPoints: import('pixi.js').ObservablePoint;
        isCustomAnchor: boolean;
        displayWidth: import('@signe/reactive').WritableSignal<number>;
        displayHeight: import('@signe/reactive').WritableSignal<number>;
        overrideProps: string[];
        layout: any;
        onBeforeDestroy: import('./DisplayObject').OnHook | null;
        onAfterMount: import('./DisplayObject').OnHook | null;
        subjectInit: import('rxjs').BehaviorSubject<any>;
        disableLayout: boolean;
        "__#1@#registeredEvents": Map<string, Function>;
        readonly deltaRatio: any;
        readonly parentIsFlex: any;
        onInit(props: import('..').Props): void;
        onMount({ parent, props }: Element</*elided*/ any>, index?: number): Promise<void>;
        onUpdate(props: import('..').Props): void;
        onDestroy(parent: Element, afterDestroy?: () => void): Promise<void>;
        setFlexDirection(direction: import('./types/DisplayObject').FlexDirection): void;
        setFlexWrap(wrap: "wrap" | "nowrap" | "wrap-reverse"): void;
        setAlignContent(align: import('./types/DisplayObject').AlignContent): void;
        setAlignSelf(align: import('./types/DisplayObject').AlignContent): void;
        setAlignItems(align: import('./types/DisplayObject').AlignContent): void;
        setJustifyContent(justifyContent: "flex-start" | "flex-end" | "center" | "space-between" | "space-around"): void;
        setPosition(position: import('./types/DisplayObject').EdgeSize): void;
        setX(x: number): void;
        setY(y: number): void;
        setPadding(padding: import('./types/DisplayObject').EdgeSize): void;
        setMargin(margin: import('./types/DisplayObject').EdgeSize): void;
        setGap(gap: import('./types/DisplayObject').EdgeSize): void;
        setBorder(border: import('./types/DisplayObject').EdgeSize): void;
        setPositionType(positionType: "relative" | "absolute"): void;
        setWidth(width: number): void;
        setHeight(height: number): void;
        getWidth(): number;
        getHeight(): number;
        setMinWidth(minWidth: number | string): void;
        setMinHeight(minHeight: number | string): void;
        setMaxWidth(maxWidth: number | string): void;
        setMaxHeight(maxHeight: number | string): void;
        setAspectRatio(aspectRatio: number): void;
        setFlexGrow(flexGrow: number): void;
        setFlexShrink(flexShrink: number): void;
        setFlexBasis(flexBasis: number | string): void;
        setRowGap(rowGap: number): void;
        setColumnGap(columnGap: number): void;
        setTop(top: number | string): void;
        setLeft(left: number | string): void;
        setRight(right: number | string): void;
        setBottom(bottom: number | string): void;
        setObjectFit(objectFit: import('./types/DisplayObject').ObjectFit): void;
        setObjectPosition(objectPosition: import('./types/DisplayObject').ObjectPosition): void;
        setTransformOrigin(transformOrigin: import('./types/DisplayObject').TransformOrigin): void;
    };
    [x: string]: any;
};
export declare class CanvasDOMContainer extends CanvasDOMContainer_base {
    disableLayout: boolean;
    onInit(props: any): void;
}
export interface CanvasDOMContainer extends DisplayObjectProps {
}
export declare const DOMContainer: ComponentFunction<any>;
export {};
//# sourceMappingURL=DOMContainer.d.ts.map