import { Element } from '../engine/reactive';
import { OnHook } from './DisplayObject';
import { ComponentFunction } from '../engine/signal';
import { DisplayObjectProps } from './types/DisplayObject';

interface DOMContainerProps extends DisplayObjectProps {
    element: string | {
        value: HTMLElement;
    };
    textContent?: string;
    attrs?: Record<string, any> & {
        class?: string | string[] | Record<string, boolean> | {
            items?: string[];
        } | {
            value?: string | string[] | Record<string, boolean>;
        };
        style?: string | Record<string, string | number> | {
            value?: string | Record<string, string | number>;
        };
    };
    onBeforeDestroy?: OnHook;
}
export declare class CanvasDOMElement {
    element: HTMLElement;
    private eventListeners;
    private onBeforeDestroy;
    private valueSignal;
    private isFormElementType;
    /**
     * Checks if the element is a form element that supports the value attribute
     * @param elementType - The element type string from props
     * @returns true if the element is a form element with value support
     */
    private isFormElement;
    onInit(props: DOMContainerProps): void;
    onMount(context: Element<CanvasDOMElement>): void;
    onUpdate(props: DOMContainerProps): void;
    onDestroy(parent: Element<CanvasDOMElement>, afterDestroy: () => void): Promise<void>;
}
export interface CanvasDOMElement extends DisplayObjectProps {
}
export declare const DOMElement: ComponentFunction<DOMContainerProps>;
export {};
//# sourceMappingURL=DOMElement.d.ts.map