import { Directive } from '../engine/directive';
import { Element } from '../engine/reactive';

export interface Tick {
    timestamp: number;
    deltaTime: number;
    frame: number;
    deltaRatio: number;
}
export declare class Scheduler extends Directive {
    private maxFps?;
    private fps;
    private deltaTime;
    frame: number;
    private timestamp;
    private requestedDelay;
    private lastTimestamp;
    private _stop;
    private tick;
    onInit(element: Element): void;
    onDestroy(): void;
    onMount(element: Element): void;
    onUpdate(props: any): void;
    nextTick(timestamp: number): void;
    /**
     * start the schedule
     * @return {Scheduler} returns this scheduler instance
     */
    start(options?: {
        maxFps?: number;
        fps?: number;
        delay?: number;
    }): this;
    stop(): void;
}
//# sourceMappingURL=Scheduler.d.ts.map