import { Container } from 'pixi.js';
import { Directive } from '../engine/directive';
import { Element } from '../engine/reactive';

/**
 * Sound directive for playing audio with support for spatial audio and multiple sound sources
 *
 * This directive manages audio playback using Howler.js library. It supports:
 * - Single or multiple sound sources
 * - Spatial audio with distance-based volume calculation
 * - All standard audio controls (play, pause, volume, etc.)
 * - Event handling for audio lifecycle
 *
 */
export declare class Sound extends Directive {
    private sounds;
    private eventsFn;
    private maxVolume;
    private maxDistance;
    private tickSubscription?;
    onInit(element: Element<Container>): void;
    onMount(element: Element<Container>): void;
    onUpdate(props: any): void;
    onDestroy(): void;
}
//# sourceMappingURL=Sound.d.ts.map