import { Application, ApplicationOptions } from 'pixi.js';
import { ComponentFunction } from './signal';

/**
 * Bootstraps a canvas element and renders it to the DOM.
 *
 * @param rootElement - The HTML element where the canvas will be rendered. Can be null.
 * @param canvas - A Promise that resolves to an Element representing the canvas component.
 * @returns A Promise that resolves to the rendered canvas element.
 * @throws {Error} If the provided element is not a Canvas component.
 */
export declare const bootstrapCanvas: (rootElement: HTMLElement | null, canvas: ComponentFunction<any>, options?: ApplicationOptions) => Promise<{
    canvasElement: import('./reactive').Element<import('..').ComponentInstance>;
    app: Application<import('pixi.js').Renderer>;
}>;
//# sourceMappingURL=bootstrap.d.ts.map